Attribute VB_Name = "Module1"
'This module was written to process data stored in four worksheets
'Programmed by Wenhua Wei
'15/6/2002
Option Explicit
    'module variables
    Dim myRange As Range
    Dim i As Integer
    Dim k As Integer
    Dim m As Integer
    Dim strClass As String

Sub processSheets()
'this routine is to loop through each data worksheet and select
'data region properly, then call projectResult() routine
    Dim intRow As Integer
    
    Sheets("Additive").Select
    Range("A6").Select
    currentRange    'select existing list
    Selection.ClearContents
    Range("A6").Name = "CurrentAdditive"
    
    'start fill data in the Analysis3 sheet from results
    For k = 1 To 4
        'working on one worksheet a step
        Select Case k
            Case 1
                Sheets("ClassNZ").Select
                strClass = "NZ"
            Case 2
                Sheets("Class5").Select
                strClass = "5"
            Case 3
                Sheets("Class6").Select
                strClass = "6"
            Case 4
                Sheets("Class7").Select
                strClass = "7"
        End Select
        
        'set up the data range correctly
        Range("A6").Select
        currentRange    'select current data list
        Set myRange = Selection
        intRow = myRange.Rows.Count
        For i = 1 To intRow
            If myRange(i, 12) <> "" Then
                'maternal additive effects available
                m = 12
            Else
                m = 0
            End If
            writeAdditive m
        Next
    Next
End Sub

Sub currentRange()
    'this routine is to select current range of a data list
    Dim newRange As Range
    
    ActiveCell.CurrentRegion.Select
    Set newRange = Selection
    newRange.Offset(1, 0).Select
    newRange.Offset(1, 0).Resize(newRange.Rows.Count - 1, _
                newRange.Columns.Count).Select

End Sub

Sub writeAdditive(ByVal m As Integer)
    'write direct additive results to sheet 'Additive'
    
    Sheets("Additive").Select
    Range("CurrentAdditive").Select
        
    ActiveCell.Value = strClass 'class name
    ActiveCell.Offset(1, 0).Value = strClass
    ActiveCell.Offset(, 1).Value = myRange.Cells(i, 1) 'trait name
    ActiveCell.Offset(1, 1).Value = myRange.Cells(i, 1)
    ActiveCell.Offset(, 2).Value = myRange.Cells(i, 2) 'breed one
    ActiveCell.Offset(1, 2).Value = myRange.Cells(i, 3) 'breed two
    ActiveCell.Offset(, 3).Value = myRange.Cells(i, 4) + _
                            myRange.Cells(i, 6) 'direct additive
    ActiveCell.Offset(1, 3).Value = myRange.Cells(i, 4) - _
                            myRange.Cells(i, 6) 'direct additive
    If m = 12 Then
        ActiveCell.Offset(, 4).Value = myRange.Cells(i, 4) + _
                            myRange.Cells(i, 12) 'maternal additive
        ActiveCell.Offset(1, 4).Value = myRange.Cells(i, 4) - _
                            myRange.Cells(i, 12) 'maternal additive
    End If
    
    ActiveCell.Offset(2, 0).Name = "CurrentAdditive"
End Sub


