Attribute VB_Name = "Module1"
'This module was written to process data stored in four worksheets
'Programmed by Wenhua Wei
'15/6/2002
Option Explicit
    'module variables
    Dim myRange As Range
    Dim i As Integer
    Dim j As Integer
    Dim k As Integer
    Dim m As Integer
    Dim n As Integer
    Dim p As Integer
    Dim strClass As String

Sub processSheets(ByVal blnAdditive As Boolean)
'this routine is to loop through each data worksheet and select
'data region properly, then call projectResult() routine
    Dim intRow As Integer
    
    If Not blnAdditive Then 'process heterosis estimates
        'clear up the Analysis3 worksheet first
        Sheets("Analysis3").Select
        Range("A6").Select
        currentRange    'select existing list
        Selection.ClearContents
        Range("A6").Name = "CurrentCell"
    Else
        Sheets("Additive").Select
        Range("A6").Select
        currentRange    'select existing list
        Selection.ClearContents
        Range("A6").Name = "CurrentAdditive"
    End If
    
    'start fill data in the Analysis3 sheet from results
    For k = 1 To 4
        'working on one worksheet a step
        Select Case k
            Case 1
                Sheets("ClassNZ").Select
                strClass = "NZ"
            Case 2
                Sheets("Class5").Select
                strClass = "5"
            Case 3
                Sheets("Class6").Select
                strClass = "6"
            Case 4
                Sheets("Class7").Select
                strClass = "7"
        End Select
        
        'set up the data range correctly
        Range("A6").Select
        currentRange    'select current data list
        Set myRange = Selection
        intRow = myRange.Rows.Count
'implement different processing method process myRange row by row
        If Not blnAdditive Then
            'and write results to worksheet "Analysis"
            For i = 1 To intRow
                If myRange.Cells(i, 13) <> "" Then
                    'd1x2 get value
                    m = 2   'breed 1 index
                    n = 3   'breed 2 index
                    j = 13  'dominance start index
                    p = 25  'maternal start index
                    Call writeRecord(m, n, j, p)
                End If
                
                If myRange.Cells(i, 15) <> "" Then
                    'd1x3 get value
                    m = 2
                    n = 4
                    j = 15
                    p = 27
                    Call writeRecord(m, n, j, p)
                End If
                
                If myRange.Cells(i, 17) <> "" Then
                    'd2x3 get value
                    m = 3
                    n = 4
                    j = 17
                    p = 29
                    writeRecord m, n, j, p
                End If
            Next
        Else    'extract additive info and write to 'Additive'
            For i = 1 To intRow
                If myRange(i, 19) <> "" And myRange(i, 19) <> 0 Then
                    'maternal additive effects available
                    m = 19
                Else
                    m = 0
                End If
                writeAdditive m
            Next
        End If
    Next
End Sub

Sub writeRecord(ByVal m, ByVal n, ByVal j, ByVal p)
'write one record to worksheet "analysis"
    Sheets("Analysis3").Select
    Range("CurrentCell").Select
    ActiveCell.Value = strClass 'class name
    'get trait name
    ActiveCell.Offset(, 1).Value = myRange.Cells(i, 1)
    ActiveCell.Offset(, 2).Value = myRange.Cells(i, m) 'breed 1
    ActiveCell.Offset(, 3).Value = myRange.Cells(i, n) 'breed 2
    ActiveCell.Offset(, 4).Value = myRange.Cells(i, 5) 'm
    ActiveCell.Offset(, 5).Value = myRange.Cells(i, 6) 'SD of m
    ActiveCell.Offset(, 6).Value = myRange.Cells(i, j) 'Dmxn
    ActiveCell.Offset(, 7).Value = myRange.Cells(i, j + 1) 'SD
    ActiveCell.Offset(, 8).Value = myRange.Cells(i, p) 'DMmxn
    ActiveCell.Offset(, 9).Value = myRange.Cells(i, p + 1) 'SD
    ActiveCell.Offset(1, 0).Select
    Selection.Name = "CurrentCell"  'set new cell reference to
End Sub

Sub currentRange()
    'this routine is to select current range of a data list
    Dim newRange As Range
    
    ActiveCell.CurrentRegion.Select
    Set newRange = Selection
    newRange.Offset(1, 0).Select
    newRange.Offset(1, 0).Resize(newRange.Rows.Count - 1, _
                newRange.Columns.Count).Select

End Sub

Sub writeAdditive(ByVal m As Integer)
    'write direct additive results to sheet 'Additive'
    Dim ii As Integer   'loop counter
    Dim jj As Integer   'step value
    Dim kk As Integer   'step value
    
    Sheets("Additive").Select
    Range("CurrentAdditive").Select
    jj = 0
    kk = 0
    For ii = 0 To 2  'three breeds in one go
        ActiveCell.Offset(ii, 0).Value = strClass 'class name
        ActiveCell.Offset(ii, 1).Value = myRange.Cells(i, 1) 'trait name
        ActiveCell.Offset(ii, 2).Value = myRange.Cells(i, 2 + kk) 'breed
        ActiveCell.Offset(ii, 3).Value = myRange.Cells(i, 5) + _
                                myRange.Cells(i, 7 + jj) 'direct additive
        If m = 19 Then
            ActiveCell.Offset(ii, 4).Value = myRange.Cells(i, 5) + _
                                myRange.Cells(i, m + jj) 'maternal additive
        End If
        kk = kk + 1 'breed step increase by 1
        jj = jj + 2 'additive step increase by 2
    Next
    ActiveCell.Offset(3, 0).Name = "CurrentAdditive"
End Sub
