Attribute VB_Name = "Module1"
Option Explicit
Public gstrTrait As String  'global var for trait name
Public gstrClass As String  'global var for Class name
Public gintPure As Integer  'global var for number of purebreeds
'Public gintNum As Integer
Public gintBreedNum As Integer 'number of genotypes
    'for number of purebreeds and genotypes in the model
'create a user-defined type for genotype
Type Genotype
    intBreedID As Integer   'Genotype identity code
    strBreedName As String  'short name of the genotype
    intSireID As Integer    'the sire breed ID of the genotype
    intDamID As Integer     'the dam breed ID of the genotype
End Type

'define a type for meta-analysis means
Type MetaData
    intBreedID As Integer   'genotype identity code
    sngMean As Single       'mean value
    sngSE As Single         'standard error value
End Type

'define a global array to store genotypes
Public gBreed(200) As Genotype
Public gintPureID() As Integer   'stores the purebred ID
Public gstrParameter() As String   'stores names of parameters
Public gChiTable(1 To 2, 1 To 120) As Single
'table containing chi values to test significance
Public xl As Object        'application object for automation
Public myBook As Workbook  'an Excel workbook
Public mySheet As Worksheet    'an Excel worksheet


'now define module variables
Dim mintFirst() As Integer  'store BreedID of first crosses
Dim mintSecond() As Integer 'store BreedID of second crosses
Dim mintFurther() As Integer 'breedID of further crosses
Dim mintFir As Integer  'number of first cross genotypes
Dim mintSec As Integer  'number of second cross genotypes
Dim mintFur As Integer  'number of further cross genotypes
Dim mMetaData() As MetaData 'store reading data in whole
Dim mLookup() As Integer    'look up table including 3
    'fields: BreedID, data available, index of Pedigree
Dim mintGen As Integer  'number of genotypes with data
Dim mintN As Integer    'total number of genotypes
'2-breed Case: level of epistatic effects, 3 for primary level
'3/4-breed case: used to store the capacity after restrictions
Dim mintMult As Integer
Dim mMyData() As MetaData   'store current processing data
Dim mintRecords As Integer  'number of records of means from a file
Dim mPedigree() As Single   '3-dimensional array store the Pedigree
'matrix: rows refer to the number of pure breeds. Columns refer to
'mintGen ie number of breeds with data.  Pages refer to genetic
'parameters as follows: 1:a; 2:d1; 3:am; 4:d1m; 5:ap; 6:d1p; 7:agm
'8:d1gm; 9:c(cytoplasmatic effect)
Dim mInterDominance() As Single '3-dimensional array store effect
'of dominance x dominance. rows = gintPure*(gintPure-1)/2; Columns
'refers as mintGen, pages as follows: 1:d2; 2:d2m; 3:d2p; 4:d2gm
Dim mXMatrix() As Single    'to store the x matrix to be used
'need to think about if mPedigree() and mInterDominance necessary
Dim mintSign() As Integer   'store info of availability for each
'parameter under consideration; shared by both CBE1 and CBE3
Dim mintP1Stuff() As Integer  'store stage number for p1 parameters
Dim mblnMessage As Boolean      'a flag to give out right message


'this routine finds the crossbred genotypes
Sub getGenotypes()
    Dim i As Integer    'loop counter
    Dim j As Integer    'inner loop counter
    Dim k As Integer    'inner loop counter
'estimate array size
    i = gintPure ^ 2 - gintPure
    ReDim mintFirst(i - 1) As Integer
    ReDim mintSecond(2 * i) As Integer
    ReDim mintFurther(2 * i) As Integer
'find the first crosses BreedID
    mintFir = 0
    'Print "First crosses:"
    For i = 0 To gintBreedNum - 1
        With gBreed(i)
        Select Case gintPure
        Case 2
            If (.intSireID = gintPureID(0) Or .intSireID = gintPureID(1)) And _
                (.intDamID = gintPureID(0) Or .intDamID = gintPureID(1)) And _
                .intSireID <> .intDamID Then
               mintFirst(mintFir) = .intBreedID
               'Print mintFirst(mintFir); Tab(10); .intSireID; Tab(10); .intDamID
               mintFir = mintFir + 1
            End If
        Case 3
            If (.intSireID = gintPureID(0) Or .intSireID = gintPureID(1) Or _
                .intSireID = gintPureID(2)) And (.intDamID = gintPureID(0) _
                Or .intDamID = gintPureID(1) Or .intDamID = gintPureID(2)) _
                And .intSireID <> .intDamID Then
               mintFirst(mintFir) = .intBreedID
               'Print mintFirst(mintFir); Tab(10); .intSireID; Tab(10); .intDamID
               mintFir = mintFir + 1
            End If
        Case 4
            If (.intSireID = gintPureID(0) Or .intSireID = gintPureID(1) Or _
                .intSireID = gintPureID(2) Or .intSireID = gintPureID(3)) And _
                (.intDamID = gintPureID(0) Or .intDamID = gintPureID(1) Or _
                .intDamID = gintPureID(2) Or .intDamID = gintPureID(3)) And _
                .intSireID <> .intDamID Then
               mintFirst(mintFir) = .intBreedID
               'Debug.Print mintFirst(mintFir); Tab(10); .intSireID; Tab(10); .intDamID
               mintFir = mintFir + 1
            End If
        End Select
        End With
    Next i
    
'find second crosses including backcrosses and F2
    mintSec = 0
    For i = 0 To gintBreedNum - 1
        With gBreed(i)
        For k = 0 To mintFir - 1
            'get F2 crosses
            If .intSireID = mintFirst(k) And .intDamID = mintFirst(k) Then
                    mintSecond(mintSec) = .intBreedID
                    mintSec = mintSec + 1
            End If
            For j = 0 To gintPure - 1
                'get back crosses
                If (.intSireID = mintFirst(k) And .intDamID = gintPureID(j)) Or _
                    (.intDamID = mintFirst(k) And .intSireID = gintPureID(j)) Then
                    mintSecond(mintSec) = .intBreedID
                    mintSec = mintSec + 1
                End If
            Next j
        Next k
        End With
    Next i
    
'find further crosses using the backcrosses or F2
'note that F1 x backcrosses or rotation genotypes not included
'these need further modifications by adding one more loop
    mintFur = 0
    For i = 0 To gintBreedNum - 1
        With gBreed(i)
        For k = 0 To mintSec - 1
            'insert a new loop here to extract say F1 x F2 etc
            For j = 0 To gintPure - 1
                'get further crosses
                If (.intSireID = mintSecond(k) And .intDamID = gintPureID(j)) Or _
                    (.intDamID = mintSecond(k) And .intSireID = gintPureID(j)) Then
                    mintFurther(mintFur) = .intBreedID
                    mintFur = mintFur + 1
                End If
            Next j
        Next k
        End With
    Next i
    'get total number of genotypes of interest
    mintN = gintPure + mintFir + mintSec + mintFur
End Sub

'this routine can be used many times in mutilple traits situation
Sub ReadFile(strFilePath As String)
    Dim intRecord As Integer    'store number of records
    Dim intFileNo As Integer    'store free file number
    Dim strDummy As String * 37 'temporary string var
    Dim sngA As Single          'temporary single var
    Dim sngB As Single          'temporary single var
    Dim intBreed As Integer     'temporary integer var
    Dim tempArray(1 To 200) As MetaData
    'temporary array to store reading data
    Dim i As Integer            'loop counter
    
    If Dir(strFilePath) <> "" Then  'file exists
        intFileNo = FreeFile    'assign the file number
        Open strFilePath For Input As intFileNo
        Do While Not EOF(intFileNo)
            Input #intFileNo, strDummy
            intRecord = intRecord + 1
            intBreed = Val(Trim(Left(strDummy, 10)))
            sngA = Val(Trim(Mid(strDummy, 11, 12)))
            sngB = Val(Trim(Right(strDummy, 15)))
            With tempArray(intRecord)
                .intBreedID = intBreed
                .sngMean = sngA
                .sngSE = sngB
            End With
            'Debug.Print intBreed, sngA, sngB
        Loop
        Close #intFileNo
        ReDim mMetaData(1 To intRecord)
        mintRecords = intRecord
        For i = 1 To intRecord
            mMetaData(i).intBreedID = tempArray(i).intBreedID
            mMetaData(i).sngMean = tempArray(i).sngMean
            mMetaData(i).sngSE = tempArray(i).sngSE
        Next
    End If
    
End Sub

Function getIndex(ByVal ID As Integer) As Integer
'this function returns the array index of a BreedID
    Dim i As Integer   ' loop counter
    For i = 1 To mintN
        If mLookup(i, 1) = ID Then
            getIndex = i
            Exit For
        End If
    Next
End Function

Function getID(ByVal index As Integer) As Integer
'this function returns the BreedID at an array index
    getID = mLookup(index, 1)
End Function

Function getMyID(ByVal dataIndex As Integer) As Integer
'this function returns the BreedID at the data index
'this can be done from either mLookup() or mMyData()
    getMyID = mMyData(dataIndex).intBreedID
End Function

Function getPureID(ByVal sValue As String) As Integer
'this function returns the pure breed ID afer testing the string
    Dim i As Integer            'as loop counter
    
    For i = 0 To gintBreedNum - 1
        With gBreed(i)
            If .strBreedName = sValue Then
                getPureID = .intBreedID
                Exit For
            End If
        End With
    Next i
End Function

Function getDamID(ByVal ID As Integer) As Integer
'this function returns the DamID of a breed with the BreedID
    Dim i As Integer
    'sequential search for ID
    For i = 0 To gintBreedNum - 1
        With gBreed(i)
            If .intBreedID = ID Then
                getDamID = .intDamID
                Exit For
            End If
        End With
    Next
End Function

Function getSireID(ByVal ID As Integer) As Integer
'this function returns the SireID of a breed with the BreedID
    Dim i As Integer
    'sequential search for ID
    For i = 0 To gintBreedNum - 1
        With gBreed(i)
            If .intBreedID = ID Then
                getSireID = .intSireID
                Exit For
            End If
        End With
    Next
End Function

Function getBreedName(ByVal ID As Integer) As String
'this function returns the breed short name
    Dim i As Integer
    'sequential search for ID
    For i = 0 To gintBreedNum - 1
        With gBreed(i)
            If .intBreedID = ID Then
                getBreedName = .strBreedName
                Exit For
            End If
        End With
    Next
End Function

Function isAvailable(ByVal ID As Integer) As Boolean
'this function returns info of availability of mean data
    Dim i As Integer
    For i = 1 To mintRecords
        If mMetaData(i).intBreedID = ID Then
            isAvailable = True      'data available
            Exit For
        Else
            isAvailable = False     'data unavailable
        End If
    Next
End Function

Function setLookup() As Integer
'this routine is to set up the array storing a lookup table
'any genotype with no data will zero in columns 2 and 3
    Dim i As Integer
    Dim j As Integer
    Dim k As Integer
    'redefine the right sizes,wipe out previous memory and initialise contents
    ReDim mLookup(1 To mintN, 1 To 3)
    k = 1   'start value
    j = 1   'start value
    'process the pure breed list
    For i = 0 To gintPure - 1
        mLookup(k, 1) = gintPureID(i)
        If isAvailable(gintPureID(i)) Then  'data available for this genotype
            mLookup(k, 2) = 1
            mLookup(k, 3) = j
            j = j + 1
        End If
        k = k + 1
    Next
    
    'process the first crosses
    For i = 0 To mintFir - 1
        mLookup(k, 1) = mintFirst(i)
        If isAvailable(mintFirst(i)) Then   'data available for this first cross
            mLookup(k, 2) = 1
            mLookup(k, 3) = j
            j = j + 1
        End If
        k = k + 1
    Next
    
    'process the second crosses ie. backcrosses and F2s
    For i = 0 To mintSec - 1
        mLookup(k, 1) = mintSecond(i)
        If isAvailable(mintSecond(i)) Then
            mLookup(k, 2) = 1
            mLookup(k, 3) = j
            j = j + 1
        End If
        k = k + 1
    Next
    
    'process the further crosses
    For i = 0 To mintFur - 1
        mLookup(k, 1) = mintFurther(i)
        If isAvailable(mintFurther(i)) Then
            mLookup(k, 2) = 1
            mLookup(k, 3) = j
            j = j + 1
        End If
        k = k + 1
    Next
    
    If k <> mintN + 1 Then
        MsgBox "The number of genotypes is not right"
    End If
    
    mintGen = j - 1 'decrease 1 to get the right sets of data
    
    setLookup = mintGen 'return this value for checking
End Function

Sub setMyData()
'this routine extract the associated data within the current
'breed combination from mMetaData()
    Dim i As Integer
    Dim j As Integer
    Dim k As Integer
    
    'redefine the right size of mMyData(),wipe out old memory and initialise
    ReDim mMyData(1 To mintGen)
    
    j = 1
    For i = 1 To mintN  'process the lookup table
        If mLookup(i, 2) = 1 Then
            For k = 1 To mintRecords
                If mMetaData(k).intBreedID = mLookup(i, 1) Then
                    mMyData(j).intBreedID = mMetaData(k).intBreedID
                    mMyData(j).sngMean = mMetaData(k).sngMean
                    mMyData(j).sngSE = mMetaData(k).sngSE
                    j = j + 1
                    Exit For
                End If
            Next k
        End If
    Next i
End Sub

Sub setPedigree()
'this routine fetches the info from mLookup() and gBreeds()
'then calculate the parameters for each genotype interested
'write the results to the mPedigree and mInterDominance arrays
    Dim i As Integer
    Dim j As Integer
    Dim k As Integer
    Dim ii As Integer
    Dim kk As Integer
    Dim jj As Integer
    Dim a() As Single
    Dim am() As Single
    Dim ap() As Single
    Dim agm() As Single
    Dim d1() As Single
    Dim d1m() As Single
    Dim d1p() As Single
    Dim d1gm() As Single
    Dim d2() As Single
    Dim d2m() As Single
    Dim d2p() As Single
    Dim d2gm() As Single
    Dim c() As Single
    Dim strFile As String
    
    'assign the size of the arrays dynamically
    kk = gintPure * (gintPure - 1) / 2
    ReDim a(1 To gintPure, 1 To mintN)
    ReDim am(1 To gintPure, 1 To mintN)
    ReDim ap(1 To gintPure, 1 To mintN)
    ReDim agm(1 To gintPure, 1 To mintN)
    ReDim d1(1 To gintPure, 1 To mintN)
    ReDim d1m(1 To gintPure, 1 To mintN)
    ReDim d1p(1 To gintPure, 1 To mintN)
    ReDim d1gm(1 To gintPure, 1 To mintN)
    ReDim d2(1 To kk, 1 To mintN)
    ReDim d2m(1 To kk, 1 To mintN)
    ReDim d2p(1 To kk, 1 To mintN)
    ReDim d2gm(1 To kk, 1 To mintN)
    ReDim c(1 To gintPure, 1 To mintN)
'process the purebreeds
    For i = 1 To gintPure
        a(i, i) = 1
        d1(i, i) = 1
        am(i, i) = 1
        d1m(i, i) = 1
        ap(i, i) = 1
        d1p(i, i) = 1
        agm(i, i) = 1
        d1gm(i, i) = 1
    Next
'process the crossbreds excluding cytoplasmatic effect
    For j = gintPure + 1 To mintN
        'parameters for additive and heterosis effects
        For i = 1 To gintPure
            a(i, j) = (a(i, getIndex(getSireID(getID(j)))) + _
                        a(i, getIndex(getDamID(getID(j))))) / 2
            am(i, j) = a(i, getIndex(getDamID(getID(j))))
            ap(i, j) = a(i, getIndex(getSireID(getID(j))))
            agm(i, j) = a(i, getIndex(getDamID(getDamID(getID(j)))))
            d1(i, j) = (a(i, getIndex(getSireID(getID(j)))) * _
                        a(i, getIndex(getDamID(getID(j)))))
            d1m(i, j) = d1(i, getIndex(getDamID(getID(j))))
            d1p(i, j) = d1(i, getIndex(getSireID(getID(j))))
            d1gm(i, j) = d1(i, getIndex(getDamID(getDamID(getID(j)))))
        Next i
        'parameters for dominance x dominance interactions
        For k = 1 To gintPure * (gintPure - 1) / 2
            kk = k
            For ii = 1 To gintPure - 1
                If kk < gintPure - ii + 1 Then
                    jj = kk + ii
                    Exit For
                End If
                kk = kk - gintPure + ii
            Next ii
            jj = kk + ii    '(sub S2 from first statement after For)
            'now assign values to the arrays
            d2(k, j) = a(ii, getIndex(getSireID(getID(j)))) * _
                        a(jj, getIndex(getDamID(getID(j)))) + _
                        a(ii, getIndex(getDamID(getID(j)))) * _
                        a(jj, getIndex(getSireID(getID(j))))
            d2m(k, j) = d2(k, getIndex(getDamID(getID(j))))
            d2p(k, j) = d2(k, getIndex(getSireID(getID(j))))
            d2gm(k, j) = d2(k, getIndex(getDamID(getDamID(getID(j)))))
        Next k
    Next j
'process the crossbreds on cytoplasmatic effects
    For i = 1 To mintN
        If i <= gintPure Then
            c(i, i) = 1     'pure breeds
        Else
            kk = getIndex(getDamID(getID(i)))
            Do
                kk = getIndex(getDamID(getID(kk)))
            Loop While kk > gintPure   'find a purebred dam
            c(kk, i) = 1    'crossbred
        End If
    Next
'write results to two arrays
    'set the array sizes
    ReDim mPedigree(1 To gintPure, 1 To mintGen, 1 To 9)
    ReDim mInterDominance(1 To gintPure * (gintPure - 1) / 2, _
                                1 To mintGen, 1 To 4)
    jj = 0
    For ii = 1 To mintN
        If mLookup(ii, 2) > 0 Then   'data available for this genotype
            jj = jj + 1
            For i = 1 To gintPure 'purebred block
                mPedigree(i, jj, 1) = a(i, ii)
                mPedigree(i, jj, 2) = d1(i, ii)
                mPedigree(i, jj, 3) = am(i, ii)
                mPedigree(i, jj, 4) = d1m(i, ii)
                mPedigree(i, jj, 5) = ap(i, ii)
                mPedigree(i, jj, 6) = d1p(i, ii)
                mPedigree(i, jj, 7) = agm(i, ii)
                mPedigree(i, jj, 8) = d1gm(i, ii)
                mPedigree(i, jj, 9) = c(i, ii)
                'Debug.Print mPedigree(i, jj, 1)
            Next i
            'dominance interaction effects
            For i = 1 To gintPure - 1
                For j = i + 1 To gintPure
                    k = 0
                    For kk = 1 To i - 1
                        k = k + gintPure - kk
                    Next kk
                    k = k + j - i
                    mInterDominance(k, jj, 1) = d2(k, ii)
                    mInterDominance(k, jj, 2) = d2m(k, ii)
                    mInterDominance(k, jj, 3) = d2p(k, ii)
                    mInterDominance(k, jj, 4) = d2gm(k, ii)
                Next j
            Next i
        End If
    Next ii
' the following is a test rountine. SHOULD BE DELETED
'    strFile = App.Path & "\Result.dat"
'    Open strFile For Output As #5
'    For ii = 1 To mintGen
'        Write #5, ii, getBreedName(getMyID(ii))
'        For i = 1 To gintPure
'            Write #5, mPedigree(i, ii, 1)
'        Next i
'        For i = 1 To gintPure
'           Write #5, mPedigree(i, ii, 2)
'        Next i
'        For i = 1 To gintPure - 1
'            For j = i + 1 To gintPure
'                k = 0
'                For kk = 1 To i - 1
'                    k = k + gintPure - kk
'                Next kk
'                k = k + j - i
'                Write #5, mInterDominance(k, ii, 1)
'            Next j
'        Next i
'        For i = 1 To gintPure
'            Write #5, mPedigree(i, ii, 3)
'        Next i
'        For i = 1 To gintPure
'            Write #5, mPedigree(i, ii, 4)
'        Next i
'        For i = 1 To gintPure - 1
'            For j = i + 1 To gintPure
'                k = 0
'                For kk = 1 To i - 1
'                    k = k + gintPure - kk
'                Next kk
'                k = k + j - i
'                Write #5, mInterDominance(k, ii, 2)
'            Next j
'        Next i
'        For i = 1 To gintPure
'            Write #5, mPedigree(i, ii, 5)
'        Next i
'        For i = 1 To gintPure
'            Write #5, mPedigree(i, ii, 6)
'        Next i
'        For i = 1 To gintPure - 1
'            For j = i + 1 To gintPure
'                k = 0
'                For kk = 1 To i - 1
'                    k = k + gintPure - kk
'                Next kk
'                k = k + j - i
'                Write #5, mInterDominance(k, ii, 3)
'            Next j
'        Next i
'        For i = 1 To gintPure
'            Write #5, mPedigree(i, ii, 7)
'        Next i
'        For i = 1 To gintPure
'            Write #5, mPedigree(i, ii, 8)
'        Next i
'        For i = 1 To gintPure - 1
'            For j = i + 1 To gintPure
'                k = 0
'                For kk = 1 To i - 1
'                    k = k + gintPure - kk
'                Next kk
'                k = k + j - i
'                Write #5, mInterDominance(k, ii, 4)
'            Next j
'        Next i
'        For i = 1 To gintPure
'            Write #5, mPedigree(i, ii, 9)
'        Next i
'    Next ii
'    Close #5
End Sub

Sub CompileChiTable()
    Dim i As Integer
    Dim j As Integer
    Dim iFileNo As Integer
    
    'open file 'ChiTable.txt for input
    iFileNo = FreeFile
    Open App.Path & "\ChiTable.txt" For Input As iFileNo
    i = 1
    Do Until EOF(iFileNo)
        Input #iFileNo, gChiTable(1, i), gChiTable(2, i)
        i = i + 1
    Loop
    Close #iFileNo
    
    For i = 31 To 120
        gChiTable(1, i) = 5.854728 + 1.328439 * i - 0.00256 * i ^ 2 _
                + 0.000015045 * i ^ 3 - 0.00000003722416 * i ^ 4
        gChiTable(2, i) = 9.705477 + 1.46518 * i - 0.003687 * i ^ 2 _
                + 0.000022046 * i ^ 3 - 0.00000005587346 * i ^ 4
    Next
End Sub

Function getWeight(ByVal sngSE As Single) As Single
'function to return the weight value for a standard error
'this function will be called often in the estimating routines
    If sngSE <> 0 Then
        getWeight = 1 / sngSE ^ 2
    End If
End Function

Sub setParameter()
    ReDim gstrParameter(1 To 14)    'for 2 pure breeds situations
    
    'loading the parameter names
    gstrParameter(1) = "mean"
    gstrParameter(2) = "additive"
    gstrParameter(3) = "dominance"
    gstrParameter(4) = "add. x add."
    gstrParameter(5) = "add.mat"
    gstrParameter(6) = "dom.mat"
    gstrParameter(7) = "add. x add.mat"
    gstrParameter(8) = "add.pat"
    gstrParameter(9) = "dom.pat"
    gstrParameter(10) = "add. x add.pat"
    gstrParameter(11) = "add.grmat"
    gstrParameter(12) = "dom.grmat"
    gstrParameter(13) = "add. x add.grmat"
    gstrParameter(14) = "cytoplasmatic"
End Sub

Sub setXMatrix()
'this routine is to set up x matrix for further calculation
    Dim i As Integer
    Dim j As Integer
    
    mintMult = 3
    'only primary add x add epistatic effects considered
'we set no reference of p1; intMult=3; nr% = 4 refers to
'"Kinghorn (1987) - Model 1";

    ReDim mXMatrix(1 To mintGen, 1 To 14)
    For i = 1 To mintGen
        mXMatrix(i, 1) = 1
        mXMatrix(i, 2) = mPedigree(1, i, 1) - mPedigree(2, i, 1) 'alpha-a
        mXMatrix(i, 3) = mInterDominance(1, i, 1) 'deltaij-d2
        mXMatrix(i, 4) = 2 * mPedigree(1, i, 1) * mPedigree(2, i, 1)
        'original routine 'cc1'
        j = 1 + mintMult + 1
        mXMatrix(i, j) = mPedigree(1, i, 3) - mPedigree(2, i, 3) 'alpham-am
        j = j + 1
        mXMatrix(i, j) = mInterDominance(1, i, 2) 'deltaijm-d2m
        j = j + 1
        mXMatrix(i, j) = 2 * mPedigree(1, i, 3) * _
                                mPedigree(2, i, 3) 'alpham inter
        'original routine 'cc2'
        j = 1 + 2 * mintMult + 1
        mXMatrix(i, j) = mPedigree(1, i, 5) - mPedigree(2, i, 5)
        j = j + 1
        mXMatrix(i, j) = mInterDominance(1, i, 3)
        j = j + 1
        mXMatrix(i, j) = 2 * mPedigree(1, i, 5) * _
                                mPedigree(2, i, 5) 'alphap inter
        'original routine 'cc3'
        j = 1 + 3 * mintMult + 1
        mXMatrix(i, j) = mPedigree(1, i, 7) - mPedigree(2, i, 7)
        j = j + 1
        mXMatrix(i, j) = mInterDominance(1, i, 4)
        j = j + 1
        mXMatrix(i, j) = 2 * mPedigree(1, i, 7) * _
                                mPedigree(2, i, 7) 'alphap inter
        'original routine 'cc4'
        j = 1 + 4 * mintMult + 1
        mXMatrix(i, j) = mPedigree(1, i, 9) - mPedigree(2, i, 9)
    Next
End Sub

Sub validParameter(ByVal iFlag As Integer)
'This procedure is to set up the valid parameters mainly mintSign()
'This is just useful to 2 breeds situations
'iFlag=1: additive+dominance
'iFlag=2: additive+dominance+maternal
'iFlag=3: additive+dominance+paternal effects
'iFlag=4: additive+dominance+maternal+grandmaternal effects
    Dim i As Integer
    Dim j As Integer
    Dim ii As Integer   'control variable
    ReDim mintSign(1 To 14) As Integer
    'store availability of the total 14 parameters in 2 breed case

'The algorithm to solve 2 breeds problems are:
'1)find the appropriate iFlag value.  If mintGen>9, try iFlag =4; if
'   6 < mintGen <9, try 2 and 3 as two options; if 3<mintGen<6,try 2
'2)if any of these iFlag not working, drop offending parameters
'    such as dom.mat nor add. x add.dom. Program can detect these
'3)run the whole thing checking: 0 effect or singular matrix.
'3)iteration until a true situation occurs
'4)solutions and prints if more than one (mintGen between 6 and 9)

    For i = 1 To 3  'set items 1 to 3 in mintSign()
        mintSign(i) = 1  'mean; additive; dominance
    Next
    ii = 5
    If iFlag = 2 Or iFlag = 4 Then  'set items 5 to 7 in mintSign()
        j = ii + mintMult - 1
        For i = ii To j
            mintSign(i) = 1  'maternal ones
        Next
    End If
    ii = ii + mintMult
    If iFlag = 3 Then       'set mintSign() 8 to 10
        j = ii + mintMult - 1
        For i = ii To j
            mintSign(i) = 1  'paternal ones
        Next
    End If
    ii = ii + mintMult
    If iFlag = 4 Then       'set mintSign() 11 to 13
        j = ii + mintMult - 1
        For i = ii To j
            mintSign(i) = 1  'grandmaternal ones
        Next
    End If

End Sub

Sub solveModel(ByVal blnCBE1 As Boolean, ByVal sName As String, _
                ByVal intFileNo As Integer)
'solve a model formed by either 2 or 3 or 4 breeds

    Dim XMatrix() As Single     'current X matrix for solution
    Dim intSize As Integer      'size of the mintSign() array
    Dim i As Integer
    Dim j As Integer
    Dim k As Integer
    Dim ii As Integer   'control variable
    Dim intTemp As Integer  'store how many parameters for p1
    Dim sngTemp() As Single     'temporary array to store sum values
    Dim sngTempVal As Single
    Dim strMyParameter() As String  'store the names of available parameters
    Dim intFeasible() As Integer  'store flag info
    Dim sngB() As Single
    Dim sngZ() As Single
    Dim sngC0() As Single
    Dim sngC1() As Single
    Dim sngC2() As Single
    Dim sngC3() As Single
    Dim sngY2() As Single   'used to calculate chi value
    Dim sngChi As Single    'total chi value
    Dim blnFlag As Boolean  'info to terminate the execution of model
    Dim strP1() As String   'name for additive parameters of p1
    Dim kk As Integer
    Dim jj As Integer
    Dim myRange As Range    'use to process excel sheets
    Dim strName As String      'Excel current cell name
    Dim strRange As String     'Excel range name
    Dim sngTotalAM As Single    'stores the sum of am values to test model
    
    intSize = UBound(mintSign())    'get the array size
    ReDim sngTemp(1 To intSize) As Single  'in accordance with parameters
    mblnMessage = False     'start value for this run
'Stage one: recompose XMatrix()
    Do
        blnFlag = True  'starting value
        'compute number of available parameters
        ii = numParameter(mintSign())
        
        For i = 1 To intSize
            If mintSign(i) = 1 Then
                For j = 1 To mintGen
                    'sum up the coefficient effects
                    sngTemp(i) = sngTemp(i) + Abs(mXMatrix(j, i))
                Next
            End If
        Next
        
        'reset mintSign() if a parameter is infeasible
        For i = 1 To intSize
            If mintSign(i) = 1 And sngTemp(i) < 0.0001 Then
                mintSign(i) = -1
            End If
        Next
        
        ii = numParameter(mintSign())    'new value of parameter number
        If (gintPure = 2 And ii < 3) Or (gintPure = 3 And ii < 4) Or _
            (gintPure = 4 And ii < 5) Then
            'make sure one direct dominance parameter is available
            mblnMessage = True
            Exit Sub
        End If
        ReDim strMyParameter(1 To ii)   'set the size of the array
        ReDim XMatrix(1 To mintGen, 1 To ii) 'set the size of matix for output
        ReDim intFeasible(1 To ii)
        'the three arrays above will be passed to a model funtion to solve
        
        j = 0
        For i = 1 To intSize
            If mintSign(i) = 1 Then
                j = j + 1
                strMyParameter(j) = gstrParameter(i)    'get the name
                For k = 1 To mintGen
                    XMatrix(k, j) = mXMatrix(k, i)   'get the matrix value
                Next
            End If
        Next
    'now start the model solution, ie. weighted least squares approach
        ReDim sngC0(1 To ii, 1 To ii)
        For i = 1 To ii
            For j = 1 To ii
                For k = 1 To mintGen
                    sngC0(i, j) = sngC0(i, j) + XMatrix(k, i) * _
                            XMatrix(k, j) * getWeight(mMyData(k).sngSE)
                Next
            Next
        Next
        'calculate the inverse of a positive definite symmetric matrix
        'this is mainly the routine 'm' or 'ma' in the original program
        ReDim sngC1(1 To ii, 1 To ii)
        For i = 1 To ii
            For k = i To ii
                sngC1(i, k) = sngC0(i, k)
                j = 1
                Do While i <> j
                    sngC1(i, k) = sngC1(i, k) - sngC1(j, i) * sngC1(j, k)
                    j = j + 1
                Loop    'line "ma1"
                If i = k Then   'line "ma2"
                    If sngC1(i, k) < 0 Then
                        intFeasible(i) = -1 'infeasible parameter
                        blnFlag = False     'linear relationship found
                    Else
                        sngC1(i, k) = Sqr(sngC1(i, k))
                    End If
                Else
                    If sngC1(i, i) = 0 Then
                        intFeasible(i) = -1 'infeasible parameter
                        blnFlag = False 'singular matrix
                    Else
                        sngC1(i, k) = sngC1(i, k) / sngC1(i, i)
                    End If
                End If
            Next
        Next
        
        'reset values in mintSign()
        For i = 1 To ii
            If intFeasible(i) = -1 Then
                'Debug.Print strMyParameter(i) & " not feasible"
                For j = 1 To intSize
                    If gstrParameter(j) = strMyParameter(i) Then
                        mintSign(j) = -1
                        Exit For
                    End If
                Next
            End If
        Next
    Loop While blnFlag = False

'the first place to implement difference between CBE1 and CBE2
    ReDim sngC2(1 To ii, 1 To ii)
    ReDim sngZ(1 To ii)
    If blnCBE1 Then '2-breeds situation
        ReDim sngC3(1 To ii, 1 To ii)
        ReDim sngB(1 To ii)
    Else    '3 or 4 breeds situation
        intTemp = 1       'additive must be available
        If mintP1Stuff(2) > 0 Then
            intTemp = 2   'additive maternal available
        ElseIf mintP1Stuff(3) > 0 Then
            intTemp = 3   'additive paternal available
        ElseIf mintP1Stuff(4) > 0 Then
            intTemp = 4   'additive grandmaternal available
        ElseIf mintP1Stuff(5) > 0 Then
            intTemp = 5   'cytoplasmatic effect available
        End If
        ReDim sngC3(1 To ii + intTemp, 1 To ii + intTemp)
        ReDim sngB(1 To ii + intTemp)
        ReDim strP1(1 To intTemp)
    End If
    
    'if X matrix is not singular, carry on
    For i = 1 To ii
        sngC2(i, i) = 1 / sngC1(i, i)
    Next
    For i = 2 To ii
        For k = 1 To i - 1
            For j = k To i - 1
                sngC2(i, k) = sngC2(i, k) - sngC1(j, i) * sngC2(j, k)
            Next
            sngC2(i, k) = sngC2(i, k) / sngC1(i, i)
        Next
    Next
    For i = 1 To ii
        For k = 1 To ii
            For j = 1 To ii
                'estimate of variance
                sngC3(i, k) = sngC3(i, k) + sngC2(j, i) * sngC2(j, k)
            Next
        Next
    Next
    
'get fresh estimates
    For i = 1 To ii
        For k = 1 To mintGen
            'estimate of mean
            sngZ(i) = sngZ(i) + XMatrix(k, i) * _
                    getWeight(mMyData(k).sngSE) * mMyData(k).sngMean
        Next
    Next
    For i = 1 To ii
        For j = 1 To ii
            'estimate of parameters
            sngB(i) = sngB(i) + sngC3(i, j) * sngZ(j)
        Next
    Next

'second place to implement difference between CBE1 and CBE3
    If gintPure > 2 Then
        'routine to add on p1 parameters which are not independant
        strP1(1) = "a1"
        Select Case intTemp
        Case 2
            strP1(2) = "am1"
        Case 3
            strP1(2) = "am1"
            strP1(3) = "ap1"
        Case 4
            strP1(2) = "am1"
            strP1(3) = "ap1"
            strP1(4) = "agm1"
        Case 5
            strP1(2) = "am1"
            strP1(3) = "ap1"
            strP1(4) = "agm1"
            strP1(5) = "c1"
        End Select
        jj = ii + 1
        For k = 1 To 5
            If mintP1Stuff(k) > 0 Then
                For i = 2 To gintPure
                'THIS IS WHERE CAUSE OUT OF BOUNDRY PROBLEM IN 4 BREED
                'COMBINATION COZ mintP1Stuff NOT UPDATED DURING PROCESSING
                    kk = mintP1Stuff(k) + i - 2
                    sngB(jj) = sngB(jj) - sngB(kk)
                    sngC3(jj, jj) = sngC3(jj, jj) + sngC3(kk, kk)
                Next
                For i = 2 To gintPure - 1
                    For j = i + 1 To gintPure
                        kk = mintP1Stuff(k) - 2
                        sngC3(jj, jj) = sngC3(jj, jj) + _
                                        2 * sngC3(kk + i, kk + j)
                    Next
                Next
                jj = jj + 1
            End If
        Next
    End If
'before go any further in chi value and output, check for strange solutions
'that the program hasn't prevented so far.  If any estimate is equal or
'less than the corresponding SD, it was termed as a biased solution, and
'this routine will be terminated without any output
    sngTotalAM = 0
    For i = 1 To ii
        If Sqr(sngC3(i, i)) > 100 Then  'too high a standard deviation
            'odd solution found at i parameter, the whole model discarded
            mblnMessage = True
            Exit Sub
        ElseIf Left(strMyParameter(i), 2) = "am" Then
            sngTotalAM = sngTotalAM + sngB(i) 'sum up the am value from this lot
        End If
    Next
    'now check if am1 get value, add to sum if so
    If gintPure > 2 Then
        If intTemp >= 2 Then
            sngTotalAM = sngTotalAM + sngB(ii + 2) 'am1 at position 2
            If Abs(sngTotalAM) > 0.02 Then  'allow error 0.02
                'sum of am values not equal to 0, violate rules
                mblnMessage = True
                Exit Sub    'no output
            End If
        End If
    End If
'if number of parameters is higher than mintGen, or less/equal to the
'number of pure breeds, odd or useless results will be yielded, discard
    k = mintGen - ii    'degree of freedom
    If k = 0 Then   'no df
        'don't know how to deal with that
    ElseIf k < 0 Or ii <= gintPure Then
        mblnMessage = True
        Exit Sub    'or something else?? not worthwhile for output
    End If
    
'carry on with the meaningful results
    'get chi value
    ReDim sngY2(1 To mintGen)
    For i = 1 To mintGen
        For j = 1 To ii
            sngY2(i) = sngY2(i) + XMatrix(i, j) * sngB(j)
        Next
    Next
    sngChi = 0
    For i = 1 To mintGen
        sngChi = sngChi + (mMyData(i).sngMean - sngY2(i)) ^ 2 _
                        * getWeight(mMyData(i).sngSE)
    Next
    
'output results to a file
    If sName <> "" Then
        If gstrClass = "ClassNZ" Then
            strName = "CurrentNZ"
            strRange = "HeadingNZ"
        ElseIf gstrClass = "Class5" Then
            strName = "CurrentC5"
            strRange = "HeadingC5"
        ElseIf gstrClass = "Class6" Then
            strName = "CurrentC6"
            strRange = "HeadingC6"
        Else
            strName = "CurrentC7"
            strRange = "HeadingC7"
        End If
        mySheet.Range(strName).Select
        mySheet.Application.ActiveCell.Value = gstrTrait
        mySheet.Application.ActiveCell.Offset(, 1).Value = _
                        getBreedName(gintPureID(0))
        mySheet.Application.ActiveCell.Offset(, 2).Value = _
                        getBreedName(gintPureID(1))
        
        jj = 0  'deal with 2 more breeds combination specifically
        If gintPure >= 3 Then
            mySheet.Application.ActiveCell.Offset(, 3).Value = _
                        getBreedName(gintPureID(2))
            jj = 1 'at least one more pure breed is added
        End If
        If gintPure = 4 Then
            mySheet.Application.ActiveCell.Offset(, 4).Value = _
                        getBreedName(gintPureID(3))
            jj = 2  'two more pure breeds are added
        End If
            
        Set myRange = mySheet.Range(strRange)
        'loop to print normal paramters
        kk = myRange.Cells.count      'control the flow
        For i = 1 To ii
            For j = 1 To kk Step 2    '14 paramemters as the heading
                If strMyParameter(i) = myRange.Cells(, j) Then
                    'print parameter estimates accordingly to their
                    'positions on the Excel worksheet
                    mySheet.Application.ActiveCell.Offset(, j + 2 + jj).Value = sngB(i)
                    mySheet.Application.ActiveCell.Offset(, j + 3 + jj).Value = Format(Sqr(sngC3(i, i)), "##.####")
                    Exit For
                End If
            Next j
        Next i
        'loop to print P1 parameters which depend on the normal ones
        For i = 1 To intTemp
            For j = 1 To kk Step 2
                If myRange.Cells(, j) = strP1(i) Then
                    'print each P1 parameter to the right position
                    mySheet.Application.ActiveCell.Offset(, j + 2 + jj).Value = sngB(ii + i)
                    mySheet.Application.ActiveCell.Offset(, j + 3 + jj).Value = Format(Sqr(sngC3(ii + i, ii + i)), "##.####")
                    Exit For
                End If
            Next
        Next
     
        'rename the current cell for next run
        mySheet.Application.ActiveCell.Offset(1, 0).Name = strName
        
    Else    'output to a text file for a view
        Print #intFileNo,
        Print #intFileNo,
        Print #intFileNo, "Model used: Kinghorn(1987) Model 1"
        Print #intFileNo, Date, Time
        Print #intFileNo, "Trait: " & gstrTrait & "     Class: " & gstrClass
        Print #intFileNo, "Breeds: " & getBreedName(gintPureID(0)) & _
            " and " & getBreedName(gintPureID(1));
        If gintPure = 3 Then
            Print #intFileNo, " and " & getBreedName(gintPureID(2))
        ElseIf gintPure = 4 Then
            Print #intFileNo, " and " & getBreedName(gintPureID(2)) & " and " & _
                        getBreedName(gintPureID(3));
        End If
        Print #intFileNo,
        Print #intFileNo, "--------------------------------------------------------------------"
        Print #intFileNo, Tab(7); "Parameter"; Tab(28); "Estimate"; Tab(48); "SD"; "   Significance"
        Print #intFileNo,
        Print #intFileNo, "--------------------------------------------------------------------"
        For i = 1 To ii
            Print #intFileNo, i; Tab(7); strMyParameter(i); Tab(27); sngB(i); Tab(46); _
                      Format(Sqr(sngC3(i, i)), "##.####"); Tab(60);
            sngTempVal = sngB(i) / Sqr(sngC3(i, i))
            If Abs(sngTempVal) < 1.96 Then  't-test
                Print #intFileNo, "ns"
            ElseIf Abs(sngTempVal) < 2.38 Then
                Print #intFileNo, "*"
            Else
                Print #intFileNo, "**"
            End If
        Next
        For i = 1 To intTemp
            Print #intFileNo, ii + i; Tab(7); strP1(i); Tab(27); sngB(ii + i); _
                Tab(46); Format(Sqr(sngC3(ii + i, ii + i)), "##.####"); Tab(60);
            sngTempVal = sngB(ii + i) / Sqr(sngC3(ii + i, ii + i))
            If Abs(sngTempVal) < 1.96 Then
                Print #intFileNo, "ns"
            ElseIf Abs(sngTempVal) < 2.38 Then
                Print #intFileNo, "*"
            Else
                Print #intFileNo, "**"
            End If
        Next
        
        Print #intFileNo, "--------------------------------------------------------------------"
        If k = 0 Then
            Print #intFileNo, "Zero degrees of freedom for chi^2 test"
        Else
            Print #intFileNo, "chi^2 = " & sngChi & "  ";
            If sngChi > gChiTable(2, k) Then
                Print #intFileNo, "**";
            ElseIf sngChi > gChiTable(1, k) Then
                Print #intFileNo, "*";
            Else
                Print #intFileNo, "ns";
            End If
            Print #intFileNo, " df = " & k
        End If
        Print #intFileNo, "--------------------------------------------------------------------"
        Print #intFileNo, "Generation"; Tab(18); "Observed Mean"; _
                    Tab(36); "Esitmated Mean"; Tab(54); "Deviation"
        Print #intFileNo,
        For i = 1 To mintGen
            Print #intFileNo, getBreedName(mMyData(i).intBreedID); Tab(18); _
                mMyData(i).sngMean; Tab(36); sngY2(i); Tab(54); _
                mMyData(i).sngMean - sngY2(i)
        Next
        Print #intFileNo, "--------------------------------------------------------------------"
    End If
End Sub

Function numParameter(ByRef intArray() As Integer) As Integer
    Dim i As Integer
    Dim j As Integer
    Dim intSize As Integer
    
    intSize = UBound(intArray())
    
    j = 0
    For i = 1 To intSize     'for the 14 available parameters
        If intArray(i) = 1 Then     'if feasible in estimation
             j = j + 1
        End If
    Next
    
    numParameter = j    'return value
End Function

Function validF1Cross(ByVal i As Integer, ByVal j As Integer) As Boolean
'check if a first cross genotype which has sire and dam at indexes at
'either i or j in the mLookup table, F1 ID is from mintFirst()
    Dim intIDA As Integer
    Dim intIDB As Integer
    Dim intSire As Integer
    Dim intDam As Integer
    Dim k As Integer
    
    intIDA = getID(i)   'get purebred ID A from mLookup
    intIDB = getID(j)   'get purebred ID B from mLookup
    
    validF1Cross = False    'start value
    For k = 0 To mintFir - 1
        intSire = getSireID(mintFirst(k))
        intDam = getDamID(mintFirst(k))
        If (intSire = intIDA And intDam = intIDB) Or _
                (intSire = intIDB And intDam = intIDA) Then
            'at least one F1 found
            If isAvailable(mintFirst(k)) Then
                validF1Cross = True
                Exit For
            End If
        End If
    Next
End Function

Function validSecCross(ByVal i As Integer, ByVal j As Integer, _
                        ByVal blnDam As Boolean) As Boolean
'check if a second cross genotype which has a dam resulted from
'purebreds at index i or j in the mLookup table, F1 dam from mintFirst()
    Dim intIDA As Integer
    Dim intIDB As Integer
    Dim intSire As Integer
    Dim intDam As Integer
    Dim k As Integer
    Dim kk As Integer
    
    intIDA = getID(i)   'get purebred ID A from mLookup
    intIDB = getID(j)   'get purebred ID B from mLookup
    
    validSecCross = False    'start value
    For k = 0 To mintFir - 1
        intSire = getSireID(mintFirst(k))
        intDam = getDamID(mintFirst(k))
        If (intSire = intIDA And intDam = intIDB) Or _
                (intSire = intIDB And intDam = intIDA) Then
            'at least one F1 genotype found
            For kk = 0 To mintSec - 1
                'find a second cross with the dam
                If (blnDam = True And _
                    getDamID(mintSecond(kk)) = mintFirst(k)) Or _
                    (blnDam = False And _
                    getSireID(mintSecond(kk)) = mintFirst(k)) Then
                    'check if this second cross has value
                    If isAvailable(mintSecond(kk)) Then
                        validSecCross = True
                        Exit Function
                    End If
                End If
            Next
        End If
    Next
End Function

Sub set3BXMatrix()
'set up x matrix assoicated with 3 or 4 pure breeds
'a sequential implementation was taken to avoid difficulty in
'understanding but not succinct in code.  Improvement can be made
'later when it is really necessary for extension of the program
    Dim i As Integer
    Dim j As Integer
    Dim k As Integer
    Dim intA As Integer
    Dim intB As Integer
    Dim intNumPara As Integer   'number of parameters already in
    Dim intNext As Integer  'number of parameter types can be done next
    Dim sngTemp As Single
    Dim intRes As Integer
    ReDim gstrParameter(1 To mintGen + 5) 'parameter names for 3 more breeds
    ReDim mXMatrix(1 To mintGen, 1 To mintGen + 5)
    ReDim mintSign(1 To mintGen + 5)
    ReDim mintP1Stuff(1 To 5)
    
'No reference of p1 has been set up;
'Only one model ie "Kinghorn (1987) - Model 1" is considered;
    intRes = 5
    mintP1Stuff(1) = 2  'no reference of p1
    'construct the mean part of X
    gstrParameter(1) = "m"
    For i = 1 To mintGen
        mXMatrix(i, 1) = 1
    Next
    
    'construct the additive part of X
    For i = 2 To gintPure
        gstrParameter(i) = "a" & i
        For j = 1 To mintGen
            mXMatrix(j, i) = mPedigree(i, j, 1) - mPedigree(1, j, 1) 'alpha-a
        Next
    Next
    
    'the above parameters should be available
    For i = 1 To gintPure
        mintSign(i) = 1
    Next
    
    intNumPara = gintPure       'parameters so far
    
    'some control variables
    intRes = intRes - 1
        
'dominance effect part of X as follows
    'the number of pure breeds and first crosses
    intA = gintPure + gintPure * (gintPure - 1) / 2
    'create the correct parameter names
    For k = gintPure + 1 To intA
        intB = k - gintPure  'start routine aa2
        For i = 1 To gintPure - 1
            If intB < gintPure - i + 1 Then
                Exit For
            Else
                intB = intB - gintPure + i
            End If
        Next
        j = intB + i        'end of routine aa2
        gstrParameter(k) = "d" & i & "x" & j
        'use i and j (the indexes of purebred sire and dam) to check
        'from mLookup if a resulted first cross has data available
        If validF1Cross(i, j) Then
            mintSign(k) = 1
        Else
            mintSign(k) = 0
        End If
    Next
    'now set up the corresponding matix items
    intB = gintPure 'number of pure breeds
    For k = gintPure + 1 To intA
        If mintSign(k) = 1 Then
            intB = intB + 1
            gstrParameter(intB) = gstrParameter(k)
            mintSign(intB) = mintSign(k)
            j = k - gintPure
            For i = 1 To mintGen
                mXMatrix(i, intB) = mInterDominance(j, i, 1) 'deltaij-d2
            Next
        End If
    Next
    
    intNumPara = intB       'parameters so far
    mintMult = intNumPara + 5 - intRes  'restrictions on sum(ai)

    'for 3 and 4 purebreds there will be 3 and 6 d parameters respectively
    'the overall matrix was declared as "mintGen + 5" but the 5 is for
    '"p1" specially accounting for a,am,ap,agm,c
    'we really need to make sure nothing will be out of this boundry
    If intB > mintGen - gintPure Then
        'no enough room for am parameters
        Exit Sub   'alternative
    End If
    
    intNext = mintGen - intNumPara    'Number of parameters can be added
    mintP1Stuff(2) = intNumPara + 1     'stage 2 of p1
'MATERNAL PART OF X MATRIX AS FOLLOWS
'stage 1: additive maternal parameters
    'the number of parameters re this should be "gintPure-1" due to "p1"
    For k = intB + 1 To intB + gintPure - 1  'special for p1 as additive
        mintSign(k) = 1
        i = k - (intB + 1) + 2
        gstrParameter(k) = "am" & i
        For j = 1 To mintGen
            mXMatrix(j, k) = mPedigree(i, j, 3) - _
                                mPedigree(1, j, 3) 'alpham-am
        Next
    Next
    intRes = intRes - 1
    intNumPara = intNumPara + gintPure - 1
    intNext = mintGen - intNumPara + 2  'two more for materanl ones
    mintMult = intNumPara + 5 - intRes    'restrictions on sum(ami)
    
    'test how much room left for dominance maternal parameters
    'THIS CAN BE IMPROVED SOMEHOW TO IMPLEMENT SOME OF VALID
    'PARAMETERS TO BE INCLUDED RATHER THAN GETTING RID OF ALL
    If intNext < gintPure * (gintPure - 1) / 2 Then
        Exit Sub
    End If

'stage 2: dominance maternal parameters
    intA = intNumPara + gintPure * (gintPure - 1) / 2
    'create the correct parameter names
    For k = intNumPara + 1 To intA
        intB = k - intNumPara  'start routine aa2
        For i = 1 To gintPure - 1
            If intB < gintPure - i + 1 Then
                Exit For
            Else
                intB = intB - gintPure + i
            End If
        Next
        j = intB + i        'end of routine aa2
        gstrParameter(k) = "dm" & i & "x" & j
        'check if such as F1 dam has data available
        'i,j are the indexes of purebred sire and dam
        If validSecCross(i, j, True) Then
            mintSign(k) = 1
        Else
            mintSign(k) = 0
        End If
    Next
    'now set up the corresponding matix items
    intB = intNumPara 'number of parameters in the model
    For k = intNumPara + 1 To intA
        If mintSign(k) = 1 Then
            intB = intB + 1
            gstrParameter(intB) = gstrParameter(k)
            mintSign(intB) = mintSign(k)
            j = k - intNumPara
            For i = 1 To mintGen
                mXMatrix(i, intB) = mInterDominance(j, i, 2) 'deltaijm-d2m
            Next
        End If
    Next
    intNext = mintGen - intB    'Number of parameters can be added
    intNumPara = intB       'parameters so far
    
    'test if room left for epistatic maternal parameter(just one)
    'in this category. This is where the difference between models
    If intNext < 1 Then
        Exit Sub    'no further try
    End If
'stage 3: epistatic maternal effect to implement Kinghorn model
    intNext = intNext - 1
    intNumPara = intNumPara + 1
    mintSign(intNumPara) = 1
    gstrParameter(intNumPara) = "em"
    For j = 1 To mintGen
        sngTemp = 0
        For i = 1 To gintPure
            'implement Kinghorn's model 1 here (am * am)
            sngTemp = sngTemp - mPedigree(i, j, 3) ^ 2
        Next
        mXMatrix(j, intNumPara) = sngTemp
    Next
    
'PATERNAL PART OF X MATRIX AS FOLLOWS
    If intNext < gintPure - 1 Then
        Exit Sub
    End If
    mintP1Stuff(3) = intNumPara + 1     'stage 3 of p1 stuff
    
'stage 1: additive paternal parameters
    'the number of parameters re this should be "gintPure-1"
    For k = intNumPara + 1 To intNumPara + gintPure - 1
        mintSign(k) = 1
        i = k - (intNumPara + 1) + 2
        gstrParameter(k) = "ap" & i
        For j = 1 To mintGen
            mXMatrix(j, k) = mPedigree(i, j, 5) - _
                                mPedigree(1, j, 5) 'alphap-ap
        Next
    Next
    intRes = intRes - 1
    intNumPara = intNumPara + gintPure - 1
    intNext = intNext - gintPure + 1 + 2
    mintMult = intNumPara + 5 - intRes  'restriction on sum(api)
    
    'test if room left for dominance paternal parameters
    If intNext < gintPure * (gintPure - 1) / 2 Then
        Exit Sub
    End If
'stage 2: dominance paternal parameters
    intA = intNumPara + gintPure * (gintPure - 1) / 2
    'create the correct parameter names
    For k = intNumPara + 1 To intA
        intB = k - intNumPara  'start routine aa2
        For i = 1 To gintPure - 1
            If intB < gintPure - i + 1 Then
                Exit For
            Else
                intB = intB - gintPure + i
            End If
        Next
        j = intB + i        'end of routine aa2
        gstrParameter(k) = "pm" & i & "x" & j
        'check if such as F1 dam has data available
        'i,j are the indexes of purebred sire and dam
        If validSecCross(i, j, False) Then
            mintSign(k) = 1
        Else
            mintSign(k) = 0
        End If
    Next
    'now set up the corresponding matix items
    intB = intNumPara 'number of parameters in the model
    For k = intNumPara + 1 To intA
        If mintSign(k) = 1 Then
            intB = intB + 1
            gstrParameter(intB) = gstrParameter(k)
            mintSign(intB) = mintSign(k)
            j = k - intNumPara
            For i = 1 To mintGen
                mXMatrix(i, intB) = mInterDominance(j, i, 3) 'deltaijp-d2p
            Next
        End If
    Next
    intNext = mintGen - intB    'Number of parameters can be added
    intNumPara = intB       'parameters so far
    
    'test if room left for epistatic maternal parameter(just one)
    'in this category. This is where the difference between models
    If intNext < 1 Then
        Exit Sub    'no further try
    End If
'stage 3: epistatic paternal effect to implement Kinghorn model
    intNext = intNext - 1
    intNumPara = intNumPara + 1
    mintSign(intNumPara) = 1
    gstrParameter(intNumPara) = "ep"
    For j = 1 To mintGen
        sngTemp = 0
        For i = 1 To gintPure
            'implement Kinghorn's model 1 here (am * am)
            sngTemp = sngTemp - mPedigree(i, j, 5) ^ 2
        Next
        mXMatrix(j, intNumPara) = sngTemp
    Next

'GRANDMATERNAL PART OF X MATRIX AS FOLLOWS
    'test if enough room for additive grandmaternal effects
    If intNext < gintPure - 1 Then
        Exit Sub
    End If
    mintP1Stuff(4) = intNumPara + 1     'stage 4 of p1 stuff
    
'stage 1: additive grandmaternal parameters
    'the number of parameters re this should be "gintPure-1"
    For k = intNumPara + 1 To intNumPara + gintPure - 1
        mintSign(k) = 1
        i = k - (intNumPara + 1) + 2
        gstrParameter(k) = "agm" & i
        For j = 1 To mintGen
            mXMatrix(j, k) = mPedigree(i, j, 7) - _
                                mPedigree(1, j, 7) 'alphagm-agm
        Next
    Next
    intRes = intRes - 1
    intNumPara = intNumPara + gintPure - 1
    intNext = intNext - gintPure + 1
    mintMult = intNumPara + 5 - intRes  'restrictions on sum(agmi)

'That is the end of it.  Now check if cytoplasmatic effect
    'test if room left for the cytoplasmatic parameter
    If intNext < gintPure - 1 Then
        Exit Sub
    End If
    mintP1Stuff(5) = intNumPara + 1     'final stage of p1 stuff
    
    For k = intNumPara + 1 To intNumPara + gintPure - 1
        mintSign(k) = 1
        i = k - (intNumPara + 1) + 2
        gstrParameter(k) = "c" & i
        For j = 1 To mintGen
            mXMatrix(j, k) = mPedigree(i, j, 9) - _
                                mPedigree(1, j, 9) 'gamma-c
        Next
    Next
    intRes = intRes - 1
    intNumPara = intNumPara + gintPure - 1
    intNext = intNext - gintPure + 1
'IMPLEMENT THE RESTRICTIONS "sum(ai)= 0"
    'use 'mintMult' as the storage for the problem
    mintMult = intNumPara + 5 - intRes  'restrictions on sum(ci)
End Sub

Sub BatchProcess(ByVal intNum As Integer, ByVal sName As String)
'this routine encloses functions to process a legal combination
'it is set seperate to keep code short enough for management
    Dim iFlag As Integer    'control variable
    Dim i As Integer        'control variable
    Dim strFilePath As String   'file name for normal process
    Dim intFileNo As Integer    'free file number
    
    setMyData       'set up the table of data actually involved in this run
    setPedigree     'set up the pedigree matrix for this run
    If gintPure = 2 Then    'two breeds combinations
        setXMatrix     'set up the X matrix for resolution
        If sName = "" Then  'not for processing all data in one go
            strFilePath = App.Path & "\TestResult.dat"
            intFileNo = FreeFile    'assign the file number
            Open strFilePath For Append As intFileNo
        End If
        i = 0
        If intNum > 9 Then
            iFlag = 4
        ElseIf intNum > 3 Then
            iFlag = 2
            i = 3
        Else
            iFlag = 1
        End If
        
        validParameter (iFlag)  'set up parameter availability
        Call solveModel(True, sName, intFileNo) 'normal solutions
        
        If i > 0 Then
            validParameter (i)
            Call solveModel(True, sName, intFileNo) 'paternal effects solutions
        End If
    Else    'three or four breeds combinations
        set3BXMatrix
        If sName = "" Then
            strFilePath = App.Path & "\Test3BResult.dat"
            intFileNo = FreeFile    'assign the file number
            Open strFilePath For Append As intFileNo
        End If
        Call solveModel(False, sName, intFileNo)
    End If
    If strFilePath <> "" Then   'if output to a text file
        Close #intFileNo    'close the file
        If mblnMessage = False Then
            MsgBox "Current model has been solved." & vbCrLf & _
                    "Results have been saved in file:" & vbCrLf & _
                    strFilePath, , "Completion"
        Else
            MsgBox "The program was unable to solve this model" & _
                vbCrLf & "due to insufficient information", , _
                "Unsolved"
        End If
    End If
End Sub

